
//+------------------------------------------------------------------
//| %r divergence
//+------------------------------------------------------------------
//
//

#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    3
#property indicator_color1     LimeGreen
#property indicator_color2     Red
#property indicator_color3     DodgerBlue
#property indicator_width3     2
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern string TimeFrame                 = "Current time frame";
extern int    WprPeriod                 = 14;
extern bool   drawDivergences           = true;
extern bool   divergenceOnValuesVisible = true;
extern bool   divergenceOnChartVisible  = false;
extern color  divergenceBullishColor    = Aqua;
extern color  divergenceBearishColor    = Magenta;
extern string drawLinesIdentificator    = "Wprdiverge1";
extern string ___                       = "Divergence Alerts";
extern bool   divergenceAlert           = true;
extern bool   divergenceAlertsMessage   = true;
extern bool   divergenceAlertsSound     = true;
extern bool   divergenceAlertsNotify    = false;
extern bool   divergenceAlertsEmail     = false;
extern string divergenceAlertsSoundName = "alert1.wav";

extern int    levelOs                   = -90;
extern int    levelOb                   = -10;
extern int    arrowSize                 = 1; 

extern bool   alertsOn                  = true;
extern bool   alertsOnCurrent           = false;
extern bool   alertsMessage             = true;
extern bool   alertsSound               = true;
extern bool   alertsEmail               = true;

//
//
//
//
//

double bullishDivergence[];
double bearishDivergence[];
double wpr[];
double trend[];

//
//
//
//
//

string shortName;
string labelNames;
string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;
double pipMultiplier = 1;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
    IndicatorBuffers(4);
    SetIndexBuffer(0,bullishDivergence); SetIndexStyle(0,DRAW_ARROW,0,arrowSize); SetIndexArrow(0,233);
    SetIndexBuffer(1,bearishDivergence); SetIndexStyle(1,DRAW_ARROW,0,arrowSize); SetIndexArrow(1,234);  
    SetIndexBuffer(2,wpr);
    SetIndexBuffer(3,trend);
    SetLevelValue(0,0);
    SetLevelValue(1,levelOs);
    SetLevelValue(2,levelOb);
    
    //
    //
    //
    //
    //
   
    timeFrame  = stringToTimeFrame(TimeFrame);   
    labelNames = "Wpr_DivergenceLine "+drawLinesIdentificator+":";
    shortName  = timeFrameToString(timeFrame)+"  Wpr ("+WprPeriod+")";
    IndicatorShortName(shortName);
   
    //
    //
    //
    //
    //
   
    indicatorFileName = WindowExpertName();
    calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
    returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
return(0);
}

//
//
//
//
//

int deinit()
{
   int length=StringLen(labelNames);
   for(int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i);
      if(StringSubstr(name,0,length) == labelNames)  ObjectDelete(name);   
   }
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)  { bullishDivergence[0] = limit+1; return(0); }
         if (Digits==3 || Digits==5) 
               pipMultiplier = 10;
         else  pipMultiplier = 1; 

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for(int i=limit; i>=0; i--)
      {
         double hi   = High[iHighest(NULL,0, MODE_HIGH,WprPeriod,i)];
         double lo   =  Low[iLowest(NULL, 0,  MODE_LOW,WprPeriod,i)];
         if (hi!=lo)      
              wpr[i] = -100*(hi-Close[i]) / (hi-lo);
         else wpr[i] = 0;  
            trend[i] = trend[i+1]; 
 
              if (wpr[i] > levelOs) trend[i] =  1;
              if (wpr[i] < levelOb) trend[i] = -1;
              if (drawDivergences)
              {
                CatchBullishDivergence(i);
                CatchBearishDivergence(i);
              }         
      
      }
      manageAlerts();
    return(0);
    }
    
    //
    //
    //
    //
    //       
    
    limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    for(i=limit; i>=0; i--)
    {
       int y = iBarShift(NULL,timeFrame,Time[i]);
          wpr[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,drawDivergences,divergenceOnValuesVisible,divergenceOnChartVisible,divergenceBullishColor,divergenceBearishColor,drawLinesIdentificator,"",divergenceAlert,divergenceAlertsMessage,divergenceAlertsSound,divergenceAlertsNotify,divergenceAlertsEmail,divergenceAlertsSoundName,2,y);
          trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,drawDivergences,divergenceOnValuesVisible,divergenceOnChartVisible,divergenceBullishColor,divergenceBearishColor,drawLinesIdentificator,"",divergenceAlert,divergenceAlertsMessage,divergenceAlertsSound,divergenceAlertsNotify,divergenceAlertsEmail,divergenceAlertsSoundName,3,y);
          bullishDivergence[i] = EMPTY_VALUE;
          bearishDivergence[i] = EMPTY_VALUE;
             
          int firstBar = iBarShift(NULL,0,iTime(NULL,timeFrame,y));
          if (i==firstBar)
          {
             bullishDivergence[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,drawDivergences,divergenceOnValuesVisible,divergenceOnChartVisible,divergenceBullishColor,divergenceBearishColor,drawLinesIdentificator,"",divergenceAlert,divergenceAlertsMessage,divergenceAlertsSound,divergenceAlertsNotify,divergenceAlertsEmail,divergenceAlertsSoundName,0,y);
             bearishDivergence[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,drawDivergences,divergenceOnValuesVisible,divergenceOnChartVisible,divergenceBullishColor,divergenceBearishColor,drawLinesIdentificator,"",divergenceAlert,divergenceAlertsMessage,divergenceAlertsSound,divergenceAlertsNotify,divergenceAlertsEmail,divergenceAlertsSoundName,1,y);
          }
   } 
   manageAlerts();  
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CatchBullishDivergence(int shift)
{
   shift++;
         bullishDivergence[shift] = EMPTY_VALUE;
            ObjectDelete(labelNames+"l"+DoubleToStr(Time[shift],0));
            ObjectDelete(labelNames+"l"+"os" + DoubleToStr(Time[shift],0));            
   if(!IsIndicatorLow(shift)) return;  

   //
   //
   //
   //
   //
      
   int currentLow = shift;
   int lastLow    = GetIndicatorLastLow(shift+1);
    
   if(wpr[currentLow] > wpr[lastLow] && Low[currentLow] < Low[lastLow])
   {
      bullishDivergence[currentLow] = wpr[currentLow]-Point*pipMultiplier;
      if(divergenceOnChartVisible  == true) DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow],    divergenceBullishColor,STYLE_SOLID);
      if(divergenceOnValuesVisible == true) DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],wpr[currentLow],wpr[lastLow],divergenceBullishColor,STYLE_SOLID);
      if(divergenceAlert           == true) DisplayAlert("Classical bullish divergence on: ",currentLow); 
   }
     
   //
   //
   //
   //
   //
        
   if(wpr[currentLow] < wpr[lastLow] && Low[currentLow] > Low[lastLow])
   {
      bullishDivergence[currentLow] = wpr[currentLow]-Point*pipMultiplier;
      if(divergenceOnChartVisible  == true) DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow],    divergenceBullishColor,STYLE_DOT);
      if(divergenceOnValuesVisible == true) DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],wpr[currentLow],wpr[lastLow],divergenceBullishColor,STYLE_DOT);
      if(divergenceAlert           == true) DisplayAlert("Reverse bullish divergence on: ",currentLow); 
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CatchBearishDivergence(int shift)
{
   shift++; 
         bearishDivergence[shift] = EMPTY_VALUE;
            ObjectDelete(labelNames+"h"+DoubleToStr(Time[shift],0));
            ObjectDelete(labelNames+"h"+"os" + DoubleToStr(Time[shift],0));            
   if(IsIndicatorPeak(shift) == false) return;
   
   //
   //
   //
   //
   //
   
   int currentPeak = shift;
   int lastPeak    = GetIndicatorLastPeak(shift+1);
      
   if(wpr[currentPeak] < wpr[lastPeak] && High[currentPeak]>High[lastPeak])
   {
       bearishDivergence[currentPeak] = wpr[currentPeak]+Point*pipMultiplier;
       if (divergenceOnChartVisible  == true) DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak],  divergenceBearishColor,STYLE_SOLID);
       if (divergenceOnValuesVisible == true) DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],wpr[currentPeak],wpr[lastPeak],divergenceBearishColor,STYLE_SOLID);
       if (divergenceAlert           == true) DisplayAlert("Classical bearish divergence on: ",currentPeak); 
   }
   
   //
   //
   //
   //
   //

   if(wpr[currentPeak] > wpr[lastPeak] && High[currentPeak] < High[lastPeak])
   {
      bearishDivergence[currentPeak] = wpr[currentPeak]+Point*pipMultiplier;
      if (divergenceOnChartVisible  == true) DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak],  divergenceBearishColor,STYLE_DOT);
      if (divergenceOnValuesVisible == true) DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],wpr[currentPeak],wpr[lastPeak],divergenceBearishColor,STYLE_DOT);
      if (divergenceAlert           == true) DisplayAlert("Reverse bearish divergence on: ",currentPeak);
   }   
}

//
//
//
//
//

bool IsIndicatorPeak(int shift)
{
   if(wpr[shift] >= wpr[shift+1] && wpr[shift] > wpr[shift+2] && wpr[shift] > wpr[shift-1])
       return(true);
   else 
       return(false);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

bool IsIndicatorLow(int shift)
{
   if(wpr[shift] <= wpr[shift+1] && wpr[shift] < wpr[shift+2] && wpr[shift] < wpr[shift-1])
       return(true);
   else 
       return(false);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int GetIndicatorLastPeak(int shift)
{
    for(int i = shift+5; i < Bars; i++)
    {
       if(wpr[i] >= wpr[i+1] && wpr[i] > wpr[i+2] && wpr[i] >= wpr[i-1] && wpr[i] > wpr[i-2])
         return(i);
    }
return(-1);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int GetIndicatorLastLow(int shift)
{
    for (int i = shift+5; i < Bars; i++)
    {
       if (wpr[i] <= wpr[i+1] && wpr[i] < wpr[i+2] && wpr[i] <= wpr[i-1] && wpr[i] < wpr[i-2])
         return(i);
}
     
return(-1);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void DrawPriceTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
    string label = labelNames+first+"os"+DoubleToStr(t1,0);
    
      ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, 0, t1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, 0);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}

//
//
//
//
//

void DrawIndicatorTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
   int indicatorWindow = WindowFind(shortName);
   if (indicatorWindow < 0) return;
   string label = labelNames+first+DoubleToStr(t1,0);
   
      ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, indicatorWindow, t1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, 0);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}

//
//
//
//
//

void DisplayAlert(string dmessage, int shift)
{
    static datetime lastAlertTime;
    if(shift <= 2 && Time[0] != lastAlertTime)
    {
      if (divergenceAlertsMessage) Alert(dmessage, Symbol(), " , ", Period(), " minutes chart");
      if (divergenceAlertsNotify)  SendNotification(dmessage);
      if (divergenceAlertsEmail)   SendMail(StringConcatenate(Symbol()," Wpr "),dmessage);
      if (divergenceAlertsSound)   PlaySound(divergenceAlertsSoundName); 
      lastAlertTime = Time[0];
    }
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"oversold");
         if (trend[whichBar] ==-1) doAlert(whichBar,"overbought");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" wpr is ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," wpr "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}